%global dlrn_nvr octavia-tempest-plugin-1.4.1.dev36-2.20220111024859.f7718ef
%global dlrn 1
%define upstream_version 1.4.1.dev36
# Macros for py2/py3 compatibility
%if 0%{?fedora} || 0%{?rhel} > 7
%global pyver %{python3_pkgversion}
%else
%global pyver 2
%endif
%global pyver_bin python%{pyver}
%global pyver_sitelib %{expand:%{python%{pyver}_sitelib}}
%global pyver_install %{expand:%{py%{pyver}_install}}
%global pyver_build %{expand:%{py%{pyver}_build}}
# End of macros for py2/py3 compatibility
%global service octavia
%global plugin octavia-tempest-plugin
%global module octavia_tempest_plugin
%global with_doc 0

%{!?upstream_version: %global upstream_version %{version}%{?milestone}}

%global common_desc \
This package contains Tempest tests to cover the Octavia project. \
Additionally it provides a plugin to automatically load these tests into Tempest.


Name:       python-%{service}-tests-tempest
Version: 1.4.1
Release: 2.20220111024859.f7718ef%{?dist}
Summary:    Tempest Integration of Octavia Project
License:    ASL 2.0
URL:        https://git.openstack.org/cgit/openstack/%{plugin}/

Source0: octavia-tempest-plugin-1.4.1.dev36-2.20220111024859.f7718ef.tar.gz

#
# patches_ignore=DROP-IN-RPM
# patches_base=f7718ef862c568f7c761c17ac9736e650ececb73
Patch0001: 0001-Fix-testing-IPv6-VIP-network-connectivity.patch

BuildRequires:  git
BuildRequires:  openstack-macros

%description
%{common_desc}

%package -n python%{pyver}-%{service}-tests-tempest-golang
Summary:        python%{pyver}-%{service}-tests-tempest golang files
%{?python_provide:%python_provide python%{pyver}-%{service}-tests-tempest-golang}

BuildRequires:  golang
BuildRequires:  glibc-static
%if 0%{?rhel} > 7
BuildRequires:  openssl-static
BuildRequires:  zlib-static
%endif

%description -n python%{pyver}-%{service}-tests-tempest-golang
%{common_desc}

This package contains Octavia tempest golang httpd code.

%package -n python%{pyver}-%{service}-tests-tempest
Summary: %{summary}
BuildArch:  noarch
%{?python_provide:%python_provide python%{pyver}-%{service}-tests-tempest}

BuildRequires:  python%{pyver}-devel
BuildRequires:  python%{pyver}-pbr
BuildRequires:  python%{pyver}-setuptools

Obsoletes:      python-octavia-tests < 2.0.0

Requires:       python%{pyver}-%{service}-tests-tempest-golang
Requires:       python%{pyver}-pbr >= 3.1.1
Requires:       python%{pyver}-oslotest >= 3.2.0
Requires:       python%{pyver}-tempest >= 1:18.0.0
Requires:       python%{pyver}-tenacity >= 4.8.0
Requires:       python%{pyver}-dateutil
Requires:       python%{pyver}-octavia-lib >= 1.0.0
Requires:       python%{pyver}-oslo-config
Requires:       python%{pyver}-oslo-log
Requires:       python%{pyver}-oslo-utils
Requires:       python%{pyver}-requests
Requires:       python%{pyver}-six
Requires:       python%{pyver}-cryptography >= 2.1
Requires:       python%{pyver}-barbicanclient >= 4.5.2
Requires:       python%{pyver}-pyOpenSSL >= 17.1.0
Requires:       python%{pyver}-oslo-serialization >= 2.18.0
Requires:       python%{pyver}-keystoneauth1 >= 3.3.0

# Handle python2 exception
%if %{pyver} == 2
Requires:       python-ipaddress
%endif

%description -n python%{pyver}-%{service}-tests-tempest
%{common_desc}

%if 0%{?with_doc}
%package -n python-%{service}-tests-tempest-doc
Summary:        python-%{service}-tests-tempest documentation

BuildArch:  noarch

BuildRequires:  python%{pyver}-sphinx
BuildRequires:  python%{pyver}-sphinxcontrib-apidoc
BuildRequires:  python%{pyver}-sphinxcontrib-rsvgconverter
BuildRequires:  python%{pyver}-openstackdocstheme
# Required for documentation build
BuildRequires:  python%{pyver}-barbicanclient
BuildRequires:  python%{pyver}-octavia-lib
BuildRequires:  python%{pyver}-oslo-config
BuildRequires:  python%{pyver}-tempest
BuildRequires:  python%{pyver}-tenacity
BuildRequires:  python%{pyver}-pyOpenSSL

%description -n python-%{service}-tests-tempest-doc
It contains the documentation for the Octavia tempest plugin.
%endif

%prep
%autosetup -n %{plugin}-%{upstream_version} -S git

# Let's handle dependencies ourseleves
%py_req_cleanup
# Remove bundled egg-info
rm -rf %{module}.egg-info

%build
%{pyver_build}

rm -f %{module}/contrib/test_server/*bin

# Generate octavia test httpd binary from test_server.go
pushd %{module}/contrib/test_server
%if 0%{?rhel} > 7
 go build -ldflags '-compressdwarf=false -linkmode external -extldflags "-z now -pie -static -ldl -lz"' -o %{plugin}-tests-httpd test_server.go
%else
 go build -ldflags '-linkmode external -extldflags -static' -o %{plugin}-tests-httpd test_server.go
%endif
popd

# Generate Docs
%if 0%{?with_doc}
export PYTHONPATH=.
sphinx-build-%{pyver} -b html doc/source doc/build/html
# remove the sphinx build leftovers
rm -rf doc/build/html/.{doctrees,buildinfo}
%endif

%install
%{pyver_install}

# Move httpd binary to proper place
install -d -p %{buildroot}%{_libexecdir}
install -p -m 0755 %{module}/contrib/test_server/%{plugin}-tests-httpd %{buildroot}%{_libexecdir}/%{plugin}-tests-httpd
ln -s -f %{_libexecdir}/%{plugin}-tests-httpd %{buildroot}%{pyver_sitelib}/%{module}/contrib/test_server/test_server.bin

# Remove test_server.go code
rm  %{buildroot}%{pyver_sitelib}/%{module}/contrib/test_server/test_server.go

%files -n python%{pyver}-%{service}-tests-tempest-golang
%{_libexecdir}/%{plugin}-tests-httpd
%{pyver_sitelib}/%{module}/contrib/test_server/test_server.bin

%files -n python%{pyver}-%{service}-tests-tempest
%license LICENSE
%doc README.rst
%exclude %{pyver_sitelib}/%{module}/contrib/test_server/test_server.bin
%{pyver_sitelib}/%{module}
%{pyver_sitelib}/*.egg-info

%if 0%{?with_doc}
%files -n python-%{service}-tests-tempest-doc
%doc doc/build/html
%license LICENSE
%endif

%changelog
* Mon Jan 10 2022 OSP Prod Chain <dev-null@redhat.com> 1.4.1-2.20220111024859.f7718ef
- Update patches

* Mon Jun 14 2021 CPaaS User <cpaas-ops@redhat.com> - 1.4.1-2.20210611094817.f7718ef.1
- Bump release

* Fri Jun 11 2021 OSP Prod Chain <dev-null@redhat.com> 1.4.1-2.20210611094817.f7718ef
- Update patches

* Fri Jun 11 2021 Gregory Thiemonge <gthiemon@redhat.com> 1.4.1-2.20210528115848
- Fix testing IPv6 VIP network connectivity (rhbz#1970775)

* Fri May 28 2021 OSP Prod Chain <dev-null@redhat.com> 1.4.1-2.20210528115847.f7718ef
- Update patches

* Mon Apr 12 2021 OSP Prod Chain <dev-null@redhat.com> 1.3.0-1
- Update patches
- Add ALPN protocol scenario tests
- Add tests for allowed CIDRs in listeners
- Fix MismatchError in tags API tests
- Add an optional amphora admin log offloading test
- Add skip_if_not_implemented to the service client
- Add tags API tests
- Gate on octavia-v2-dsvm-tls-barbican jobs
- Add an optional tenant flow log offload test
- Add stable/ussuri jobs to check and gate lists
- Define and use octavia nodesets
- Apply Octavia hacking checks to the tempest plugin
- Set image driver to noop in noop jobs
- Fix availability zone API tests
- Fix TLS client auth tests for older amphora
- Set test_basic_traffic as smoke test
- Pin DIB to Python 2 compatible version on py2 jobs
- Switch to newer openstackdocstheme and reno versions
- Add py38 package metadata
- Introduce a simple HTTPS server for TLS test.
- Fix hacking min version to 3.0.1
- Fix amphora list-show to run in a busy environment
- [ussuri][goal] Updates for python 2.7 drop
- Use Tempest compatible version for xenial node job
- Update hacking for Python3
- Change to use memory_tracker variable
- Enable KVM libvirt type on all scenario jobs
- Add devstack plugin support

* Wed Dec 16 2020 OSP Prod Chain <dev-null@redhat.com> 1.3.0-1
- Update patches

* Tue Jul 21 2020 OSP Prod Chain <dev-null@redhat.com> 1.3.0-1
- Update patches

* Thu Jul 16 2020 OSP Prod Chain <dev-null@redhat.com> 1.3.0-1
- Update patches

* Wed May 27 2020 OSP Prod Chain <dev-null@redhat.com> 1.3.0-1
- Update patches

* Wed May 27 2020 Carlos Goncalves <cgoncalves@redhat.com> 1.3.0-0.20200506133435.0ae7f10
- Fix amphora list-show to run in a busy environment (rhbz#1840108)

* Wed May 06 2020 OSP Prod Chain <dev-null@redhat.com> 1.3.0-1
- Update patches
- Use same flake8 extensions as Octavia
- Use TLSv1.2 SSL context for barbican tests
- Fix octavia-v2-dsvm-scenario-ubuntu-xenial
- Add UDP test scenario
- Add tests for mixed IP networks UDP members
- Fix test pool to prevent immutability state errors
- Switch octavia-two-node nodeset to Bionic
- Fix timezones in certificate revocation list dates
- Run tests with algorithm supported by provider driver
- Test the Availability Zone [Profile] admin API
- Add octavia-v2-dsvm-scenario-centos-8
- Disable py2 jobs on master
- Add a mixed HTTP and HTTPS scenario test
- Add listener client authentication scenario tests
- Add TLS SNI scenario tests
- Handle NotImplemented flavor exception
- Add amphorav2 to provider list
- Add an option to reuse connections
- [train][goal] Define new 'octavia-v2-dsvm-scenario-ipv6-only' job
- Enable fail-fast on the gate queue
- Remove act-stdby-iptables scenario jobs in Stein+
- Enable tempest jobs for stable/train
- Fix placement of VRRP failover check
- Added tests for creation of listeners on same port
- Generate PDF documentation
- Fix positional formatting and add skip check
- Fix the health monitor traffic test member ERROR
- Add a test job for cinder volume backed amps
- Add an active/standby scenario test

* Tue Mar 10 2020 OSP Prod Chain <dev-null@redhat.com> 1.2.0-1
- Update patches

* Fri Oct 04 2019 OSP Prod Chain <dev-null@redhat.com> 1.2.0-1
- Generate PDF documentation
- Add a test job for cinder volume backed amps
- Merge "Add a test job for cinder volume backed amps"
- Merge "Generate PDF documentation"
- Generate PDF documentation
- Add a test job for cinder volume backed amps

* Thu Sep 26 2019 RDO <dev@lists.rdoproject.org> 1.2.0-1
- Update to 1.2.0


